#include <com rs232 esclavo.h>

#include "string.h"
#include "stdlib.h"

#FUSES NOMCLR

#use rs232(baud=9600, parity=N, xmit=PIN_C6, rcv=PIN_C7, bits=8)

char recibido[20];

int16 PAN0=0;
int16 PAN1=0;
int1 PRD0=0;
int1 PRD1=0;

void enviar();

#int_rda
void rda_isr()
{
   int8 i=0;
   while(true)
   {
      recibido[i]=getc();//RECIBE EL CARACTER

      if(recibido[i]=='\r')//busca el salto de linea \r
      {
         recibido[i]='\0';//fin de la cadena = caracter nulo \0
         enviar();
         return;
      }
      i++;
   }
}



void enviar()
{
   int8 address[10];
   int8 com[10];

   int8 PIC1[10]="PIC1";

   int8 CPAN0[10] = "PAN0";
   int8 CPAN1[10] = "PAN1";
   int8 CPRD0[10] = "PRD0";
   int8 CPRD1[10] = "PRD1";

   signed int8 result;

   memset(address, 0, sizeof(address)); //limpia los registros de la varible
   memset(com, 0, sizeof(com)); //limpia los registros de la varible

   while (true)
   {
      for (int i=0; i<=3; ++i)
      {
         address[i] = recibido[i]; //identifica el PIC
      }

      for (int i=0; i<=3; ++i)
      {
         com[i] = recibido[i+4]; //identifica el COMANDO
      }

      result = strcmp(address, PIC1);//compara, si son iguales (0), no (+-1)

      if (result==0)///si recibe la direccion
      {
         result = strcmp(com, CPAN0);//compara, si son iguales (0), no (+-1)

         if (result==0)
         {
            printf("%04lu\r",PAN0);//envia el valor del pin AN0
            return;
         }

         result = strcmp(com, CPAN1);//compara, si son iguales (0), no (+-1)

         if (result==0)
         {
            printf("%04lu\r",PAN1);//envia el valor del pin AN1
            return;
         }

         result = strcmp(com, CPRD0);//compara, si son iguales (0), no (+-1)

         if (result==0)
         {
            printf("%u\r",PRD0);//envia el valor del pin RD0
            return;
         }

         result = strcmp(com, CPRD1);//compara, si son iguales (0), no (+-1)

         if (result==0)
         {
            printf("%u\r",PRD1);//envia el valor del pin RD1
            return;
         }
      }
      return;
   }
}




void main()
{

   enable_interrupts(int_rda);
   enable_interrupts(global);

   setup_adc(ADC_CLOCK_INTERNAL);
   
   while(TRUE)
   {
      set_adc_channel (0); //Habilita el canal AN0
      delay_us(10);
      PAN0 = read_adc(); //lectura del potenciometro
      
      set_adc_channel (1); //Habilita el canal AN1
      delay_us(10);
      PAN1 = read_adc(); //lectura del sensor de gas
      
      PRD0 = input(pin_d0); // lectura del boton

      PRD1 = input(pin_d1); // lectura del sensor de presencia
   }

}
