#include <com rs232 maestro.h>

#include "string.h"
#include "stdlib.h"

#FUSES NOMCLR

#use i2c(Master, Fast, sda=PIN_B0, scl=PIN_B1, force_sw, stream=OLED_stream)//parametros I2C
#use rs232(baud=9600, parity=N, xmit=PIN_C6, rcv=PIN_C7, bits=8)


#define SH1106_128_64 //DEFINE EL MODELO DE LA PANTALLA OLED
//#define SSD1306_128_64

#include "OLED_I2C.c" //libreria oled I2C

char recibido[20];
int16 PAN0=0;
int16 PAN1=0;
int1 PRD0=0;
int1 PRD1=0;



void recive()
{
   memset(recibido, 0, sizeof(recibido)); //limpia los registros de la varible
   while(true)
   {
      if (kbhit())//espera el primer caracter
      {
         int8 i=0;
         while(true)
         {
            recibido[i]=getc();//RECIBE EL CARACTER

            if(recibido[i]=='\r')//busca el salto de linea \r
            {
               recibido[i]='\0';//fin de la cadena = caracter nulo \0
               return;
            }
            i++;
         }
      }
   }
}



void mostrar()
{
   char texto[20];

   sprintf(texto,"PAN0=%04lu",PAN0);
   OLED_DrawText(1,1,texto,1);

   sprintf(texto,"PAN1=%04lu",PAN1);
   OLED_DrawText(1,10,texto,1);

   sprintf(texto,"PRD0=%u",PRD0);
   OLED_DrawText(1,20,texto,1);

   sprintf(texto,"PRD1=%u",PRD1);
   OLED_DrawText(1,30,texto,1);

   OLED_Display();//Muestra la informacin en pantalla;
}



void main()
{

   OLED_Begin();
   OLED_ClearDisplay();

   while(TRUE)
   {
      printf("PIC1PAN0\r");
      recive();
      PAN0 = (int16)atol(recibido);  //convierte la cadena en un numero de 16bits
      
      printf("PIC1PAN1\r");
      recive();
      PAN1 = (int16)atol(recibido);  //convierte la cadena en un numero de 16bits

      printf("PIC1PRD0\r");
      recive();
      PRD0 = (int1)atoi(recibido);  //convierte la cadena en un numero de 8bits

      printf("PIC1PRD1\r");
      recive();
      PRD1 = (int1)atoi(recibido);  //convierte la cadena en un numero de 8bits
      
      mostrar();
   }

}
